# Coveo PipelineContext Component (CoveoPipelineContext)

The `PipelineContext` component injects custom contextual information into the search requests and usage analytics search events sent from a search interface.

This component is meant to be initialized on a `script` HTML tag whose `type` attribute is set to `text/context` and whose optional JSON content defines the custom information to send (each value can be set to a string or array of strings).

See Sending Custom Context Information. Note: To customize the context sent on all usage analytics events, see Sending Custom Metadata with Search, Click, or Custom Events.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- getContext
- getContextKeys
- getContextValue
- setContext
- setContextValue
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### getContext

- getContext(): Context

- - Defined in ui/PipelineContext/PipelineContext.ts :66

  Returns the current context

  #### Returns Context

### getContextKeys

- getContextKeys(): string[]

- - Defined in ui/PipelineContext/PipelineContext.ts :86

  Return all the context keys configured for context.

  #### Returns string[]

### getContextValue

- getContextValue(key: string): string | string[]

- - Defined in ui/PipelineContext/PipelineContext.ts :99

  Get the context value associated to the given key.

  If the global variable Coveo.context contains the requested key, this method will return the value contained in Coveo.context instead of the one contained internally.

  This is especially useful in a Coveo for Salesforce context, where context values can be extracted from a backend service.

  #### Parameters

  - ##### key: string

  #### Returns string | string[]

### setContext

- setContext(newContext: string | Context): void

- - Defined in ui/PipelineContext/PipelineContext.ts :54

  Available since the December 2017 Release.

  Sets a new context, replacing the previous context if applicable.

  #### Parameters

  - ##### newContext: string | Context

    The new context to set, which can be directly passed as a JSON, or as a stringified JSON.

  #### Returns void

### setContextValue

- setContextValue(contextKey: string, contextValue: string | string[]): void

- - Defined in ui/PipelineContext/PipelineContext.ts :78

  Available since the December 2017 Release.

  Sets a value for a context key, replacing the previous value if applicable.

  #### Parameters

  - ##### contextKey: string

  - ##### contextValue: string | string[]

  #### Returns void

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Constructors

### constructor

- new PipelineContext(element: HTMLElement, type: string, bindings?: IComponentBindings): PipelineContext

- Inherited from Component.constructor

  - Defined in ui/Base/Component.ts :296

  Create a new Component. Resolve all IComponentBindings if not provided.
  Create a new Logger for this component. Attach the component to the SearchInterface.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to create the component. Used to bind data on the element.

  - ##### type: string

    The unique identifier for this component. See: IComponentDefinition.ID. Used to generate the unique Coveo CSS class associated with every component.

  - ##### Default value bindings: IComponentBindings = {}

    The environment for every component. Optional, but omitting to provide one will impact performance.

  #### Returns PipelineContext

### Implements

- IPipelineContextProvider